<?php

declare(strict_types=1);

namespace App;

use Zakirullin\Mess\Mess;

final readonly class Card
{
    public function __construct(
        public string $name,
        public int $type,
        public string $fullType,
        public int $rarity,
        public string $uid,
    ) {}

    public static function fromArray(array $data): self
    {
        $mess = new Mess($data);

        return new self(
            name: $mess['name']->getString(),
            type: $mess['type']->getInt(),
            fullType: $mess['full_type']->getString(),
            rarity: $mess['rarity']->getInt(),
            uid: $mess['uid']->getString(),
        );
    }
}
